Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 891 by niro, Tue Aug 4 19:51:42 2009 UTC revision 1435 by niro, Mon Jul 25 11:01:48 2011 UTC
# Line 20  SMAGENAME="$1" Line 20  SMAGENAME="$1"
20  SMAGESUFFIX="smage2"  SMAGESUFFIX="smage2"
21  MLIBDIR=/usr/lib/mage  MLIBDIR=/usr/lib/mage
22  SMAGEVERSION="$( < ${MLIBDIR}/version)"  SMAGEVERSION="$( < ${MLIBDIR}/version)"
 SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"  
   
23    
24  ## only for tests -> normally in /etc/rc.d/init.d/functions  ## only for tests -> normally in /etc/rc.d/init.d/functions
25  COLRED="\033[1;6m\033[31m"  COLRED="\033[1;6m\033[31m"
# Line 52  export LC_ALL=C Line 50  export LC_ALL=C
50    
51  source /etc/mage.rc.global  source /etc/mage.rc.global
52  source ${MAGERC}  source ${MAGERC}
53    source ${MLIBDIR}/mage4.functions.sh
54    
55  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # set PKGDIR and BUILDDIR and BINDIR to MROOT
56  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
# Line 61  then Line 60  then
60   export BINDIR=${MROOT}/${BINDIR}   export BINDIR=${MROOT}/${BINDIR}
61  fi  fi
62    
63    # sources the smage file and uses state from distribution file if exist
64    # may helpful for repository support later on
65    smagesource()
66    {
67     local file="$1"
68     local mystate
69     local mycodename
70    
71     source ${file}
72    
73     [[ -n ${STATE} ]] && mystate="${STATE}"
74    
75     # do not overide if local state was broken or disabled!
76     case ${STATE} in
77     broken) return ;;
78     disabled) return ;;
79     esac
80    
81     if [ -f ${SMAGESCRIPTSDIR}/distribution ]
82     then
83     source ${SMAGESCRIPTSDIR}/distribution
84     [[ -n ${STATE} ]] && mystate="${STATE}"
85     fi
86     # now switch state and export it
87     STATE="${mystate}"
88    }
89    
90  showversion()  showversion()
91  {  {
92   echo -en "Magellan Source Install v${SMAGEVERSION} "   echo -en "Magellan Source Install v${SMAGEVERSION} "
# Line 75  die() Line 101  die()
101   exit 1   exit 1
102  }  }
103    
104    die_pipestatus()
105    {
106     # the status change if we do any parameter declarations!!
107     # dont do this anymore, keep this in mind!
108     #
109     # local pos="$1"
110     # local comment="$2"
111     #
112     # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"
113     #
114     [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"
115    }
116    
117  xtitle()  xtitle()
118  {  {
119   if [[ ${TERM} = xterm ]]   if [[ ${TERM} = xterm ]]
# Line 142  download_sources() Line 181  download_sources()
181   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
182   local FETCHING   local FETCHING
183   local i mirror   local i mirror
184     local wget_opts
185    
186     # filter wget command if busybox was found
187     wget_opts="$(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"
188    
189   # install SRCDIR/PNAME if not exist   # install SRCDIR/PNAME if not exist
190   [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}   [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}
191    
192   # check if FETCHING is needed   # check if FETCHING is needed
193   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )   ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} &> /dev/null )
194   if [[ $? = 0 ]]   if [[ $? = 0 ]]
195   then   then
196   # md5's ok, no fetching needed   # md5's ok, no fetching needed
# Line 187  download_sources() Line 229  download_sources()
229   then   then
230   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
231   wget \   wget \
232   --passive-ftp \   ${wget_opts} \
  --tries 3 \  
  --continue \  
  --progress bar \  
233   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
234   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
235   if [[ $? = 0 ]]   if [[ $? = 0 ]]
# Line 211  download_sources() Line 250  download_sources()
250   then   then
251   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
252   wget \   wget \
253   --passive-ftp \   ${wget_opts} \
  --tries 3 \  
  --continue \  
  --progress bar \  
254   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
255   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
256   if [[ $? = 0 ]]   if [[ $? = 0 ]]
# Line 235  download_sources() Line 271  download_sources()
271   then   then
272   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
273   wget \   wget \
274   --passive-ftp \   ${wget_opts} \
  --tries 3 \  
  --continue \  
  --progress bar \  
275   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
276   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
277   if [[ $? = 0 ]]   if [[ $? = 0 ]]
# Line 259  download_sources() Line 292  download_sources()
292   then   then
293   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
294   wget \   wget \
295   --passive-ftp \   ${wget_opts} \
  --tries 3 \  
  --continue \  
  --progress bar \  
296   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
297   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
298   if [[ $? = 0 ]]   if [[ $? = 0 ]]
# Line 283  download_sources() Line 313  download_sources()
313   then   then
314   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
315   wget \   wget \
316   --passive-ftp \   ${wget_opts} \
  --tries 3 \  
  --continue \  
  --progress bar \  
317   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
318   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
319   if [[ $? = 0 ]]   if [[ $? = 0 ]]
# Line 302  download_sources() Line 329  download_sources()
329   then   then
330   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"
331   wget \   wget \
332   --passive-ftp \   ${wget_opts} \
  --tries 3 \  
  --continue \  
  --progress bar \  
333   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI})" \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI})" \
334   "${my_SRC_URI}"   "${my_SRC_URI}"
335   fi   fi
# Line 321  download_sources() Line 345  download_sources()
345   # recheck md5 sums   # recheck md5 sums
346   echo   echo
347   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
348   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"   ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} ) || die "md5 failed"
349   echo   echo
350    
351   # not needed anymore   # not needed anymore
# Line 445  munpack() Line 469  munpack()
469   popd > /dev/null   popd > /dev/null
470   fi   fi
471   ;;   ;;
472     xz)
473     IFTAR="$(basename $SRCFILE .xz)"
474     IFTAR="${IFTAR##*.}"
475     if [[ ${IFTAR} = tar ]]
476     then
477     tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."
478     else
479     pushd ${DEST} > /dev/null
480     xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."
481     popd > /dev/null
482     fi
483     ;;
484   tbz2|mpks|mpk)   tbz2|mpks|mpk)
485   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."
486   ;;   ;;
487   tgz)   tgz)
488   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."
489   ;;   ;;
490     txz|mpkzs|mpkz)
491     tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."
492     ;;
493   rar)   rar)
494   unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."   unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."
495   ;;   ;;
# Line 504  mpatch() Line 543  mpatch()
543  mlibtoolize()  mlibtoolize()
544  {  {
545   local opts="$@"   local opts="$@"
546   [[ -z ${opts} ]] && opts="--copy --force"   [[ -z ${opts} ]] && opts="--verbose --install --force"
547    
548   libtoolize ${opts} || die "running: mlibtoolize ${opts}"   libtoolize ${opts} || die "running: mlibtoolize ${opts}"
549  }  }
550    
551    mautoreconf()
552    {
553     local opts="$@"
554     [[ -z ${opts} ]] && opts="--verbose --install --force"
555    
556     autoreconf ${opts} || die "running: mautoreconf ${opts}"
557    }
558    
559  minstalldocs()  minstalldocs()
560  {  {
561   local docfiles   local docfiles
# Line 519  minstalldocs() Line 566  minstalldocs()
566   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
567   fi   fi
568    
569     local i
570   for i in ${docfiles}   for i in ${docfiles}
571   do   do
572   cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."   if [ -f ${i} ]
573   install -m 0644 ${SRCDIR}/${i}.gz \   then
574   ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."   cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."
575     install -m 0644 ${SRCDIR}/${i}.gz \
576     ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."
577     fi
578   done   done
579  }  }
580    
# Line 543  mstripbins() Line 594  mstripbins()
594   find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null   find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
595  }  }
596    
597    mcompressdocs()
598    {
599     local bindir="$@"
600    
601     if [ -d ${bindir}/usr/share/man ]
602     then
603     echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"
604     ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man
605     fi
606    
607     if [ -d ${bindir}/usr/share/info ]
608     then
609     echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"
610     ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info
611     fi
612    }
613    
614  sminclude()  sminclude()
615  {  {
616   local i   local i
# Line 658  EOF Line 726  EOF
726  #   INHERITS              which functions get included  #   INHERITS              which functions get included
727  #   SPECIAL_FUNCTIONS     special functions which should also be added  #   SPECIAL_FUNCTIONS     special functions which should also be added
728  #                         warning: they get killed before the build starts !  #                         warning: they get killed before the build starts !
729    #   SPLIT_PACKAGES        names of all subpackages which are splitted from parent
730    #   SPLIT_PACKAGE_BASE    base package name for splitpackages
731    #                         (only in the resulting magefile}
732  #  #
733  #   MAGE_TREE_DEST        target destination of the generated tree  #   MAGE_TREE_DEST        target destination of the generated tree
734  #   REGEN_MAGE_TREE       set to 'true' to enable this  #   REGEN_MAGE_TREE       set to 'true' to enable this
# Line 668  build_mage_script() Line 739  build_mage_script()
739   local magefile   local magefile
740   local dest   local dest
741   local target   local target
742     local split_pkg_base
743   local sym   local sym
744   local depname   local depname
745    
# Line 675  build_mage_script() Line 747  build_mage_script()
747   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
748    
749   # determinate which suffix this mage file should get, if any   # determinate which suffix this mage file should get, if any
750   [ -n "$1" ] && target="-$1"   [[ $1 = --target ]] && shift && target="-$1"
751    
752     # mark package as splitpackage
753     [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"
754    
755   # name of magefile   # name of magefile
756   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"
# Line 691  build_mage_script() Line 766  build_mage_script()
766   # now build the mage file   # now build the mage file
767   > ${dest}   > ${dest}
768    
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.62 2007-11-28 10:47:50 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
769   # pgkname and state   # pgkname and state
770   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}
771   echo "STATE=\"${STATE}\"" >> ${dest}   echo "STATE=\"${STATE}\"" >> ${dest}
  echo >> ${dest}  
772    
773   # description and homepage   # description and homepage
774   echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}   echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}
775   echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}   echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}
  echo >> ${dest}  
776    
777   # special tags and vars   # special tags and vars
778   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}
779    
780   # echo MAGE_TARGETS ## note -target is needed !   # echo MAGE_TARGETS ## note -target is needed !
781   echo "MAGE_TARGETS=\"${target}\"" >> ${dest}   echo "MAGE_TARGETS=\"${target}\"" >> ${dest}
782   echo >> ${dest}  
783     # split package base
784     echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}
785    
786   # add special vars   # add special vars
787   if [ -n "${SPECIAL_VARS}" ]   if [ -n "${SPECIAL_VARS}" ]
# Line 721  build_mage_script() Line 792  build_mage_script()
792   # being tricky here :)   # being tricky here :)
793   echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}   echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}
794   done   done
  echo  >> ${dest}  
795   fi   fi
796    
797   # add at least all includes   # add at least all includes
# Line 733  build_mage_script() Line 803  build_mage_script()
803   do   do
804   echo -n " ${i}"  >> ${dest}   echo -n " ${i}"  >> ${dest}
805   done   done
806   echo  >> ${dest}   # a CRLF is needed here!
807     echo >> ${dest}
808   fi   fi
  echo >> ${dest}  
809    
810   # deps and provides   # deps and provides
811   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}
  echo >> ${dest}  
812   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}
  echo >> ${dest}  
813   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
  echo >> ${dest}  
814    
815   # add special functions   # add special functions
816   if [ -n "${SPECIAL_FUNCTIONS}" ]   if [ -n "${SPECIAL_FUNCTIONS}" ]
# Line 753  build_mage_script() Line 820  build_mage_script()
820   do   do
821   # add to mage (quotes needed !)   # add to mage (quotes needed !)
822   typeset -f "${i}" >> ${dest}   typeset -f "${i}" >> ${dest}
  echo >> ${dest}  
823   # unset to be safe (quotes needed !)   # unset to be safe (quotes needed !)
824   #unset "${i}" <-- later to get every target built   #unset "${i}" <-- later to get every target built
825   done   done
  echo  >> ${dest}  
826   fi   fi
827    
828   # pre|post-install|removes   # pre|post-install|removes
829   typeset -f preinstall >> ${dest}   typeset -f preinstall >> ${dest}
  echo  >> ${dest}  
830   typeset -f postinstall >> ${dest}   typeset -f postinstall >> ${dest}
  echo  >> ${dest}  
831   typeset -f preremove >> ${dest}   typeset -f preremove >> ${dest}
  echo  >> ${dest}  
832   typeset -f postremove >> ${dest}   typeset -f postremove >> ${dest}
  echo  >> ${dest}  
833  }  }
834    
835  regen_mage_tree()  regen_mage_tree()
# Line 779  regen_mage_tree() Line 840  regen_mage_tree()
840   if [[ ${REGEN_MAGE_TREE} = true ]]   if [[ ${REGEN_MAGE_TREE} = true ]]
841   then   then
842   # run it without targets   # run it without targets
843   if [ -z "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
844   then   then
845     # build for each target a mage file
846     # run it with several targets
847   echo   echo
848   build_mage_script   for i in ${MAGE_TARGETS}
849     do
850     build_mage_script --target "${i}"
851     done
852   echo   echo
  else  
853    
854   # build for each target an mage file   # run it for splitpackages
855     elif [[ -n ${SPLIT_PACKAGES} ]]
856     then
857     local split_pkg_base="${PNAME}"
858     # save smage environment
859     split_save_variables
860     # build for each subpackage a mage file
861   # run it with several targets   # run it with several targets
862   for i in ${MAGE_TARGETS}   echo
863     for i in ${SPLIT_PACKAGES}
864   do   do
865   echo   # get the right variables for the split
866   build_mage_script "${i}"   export PNAME="${i}"
867   echo   split_info_${i}
868     build_mage_script --split-pkg-base "${split_pkg_base}"
869     # restore smage environment
870     split_restore_variables
871   done   done
872     echo
873     # unset all saved smage variables
874     split_unset_variables
875    
876     else
877     echo
878     build_mage_script
879     echo
880   fi   fi
881   fi   fi
882    
# Line 824  regen_mage_tree() Line 907  regen_mage_tree()
907   unset postremove   unset postremove
908  }  }
909    
910    split_save_variables()
911    {
912     export SAVED_PNAME="${PNAME}"
913     export SAVED_PVER="${PVER}"
914     export SAVED_PBUILD="${PBUILD}"
915     export SAVED_PCATEGORIE="${PCATEGORIE}"
916     export SAVED_DESCRIPTION="${DESCRIPTION}"
917     export SAVED_HOMEPAGE="${HOMEPAGE}"
918     export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"
919     export SAVED_STATE="${STATE}"
920     export SAVED_PKGTYPE="${PKGTYPE}"
921     export SAVED_INHERITS="${INHERITS}"
922     export SAVED_DEPEND="${DEPEND}"
923     export SAVED_SDEPEND="${SDEPEND}"
924     export SAVED_PROVIDE="${PROVIDE}"
925     export SAVED_NOPKGBUILD="${NOPKGBUILD}"
926    
927     # bindir too
928     export SAVED_BINDIR="${BINDIR}"
929    
930     # export the SPLIT_PACKAGE_BASE
931     export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"
932    
933     # functions
934     if [[ ! -z $(typeset -f preinstall) ]]
935     then
936     # rename the old one
937     local saved_preinstall
938     saved_preinstall=SAVED_$(typeset -f preinstall)
939     eval "${saved_preinstall}"
940     export -f SAVED_preinstall
941     fi
942    
943     if [[ ! -z $(typeset -f postinstall) ]]
944     then
945     # rename the old one
946     local saved_postinstall
947     saved_postinstall=SAVED_$(typeset -f postinstall)
948     eval "${saved_postinstall}"
949     export -f SAVED_postinstall
950     fi
951    
952     if [[ ! -z $(typeset -f preremove) ]]
953     then
954     # rename the old one
955     local saved_preremove
956     saved_preremove=SAVED_$(typeset -f preremove)
957     eval "${saved_preremove}"
958     export -f SAVED_preremove
959     fi
960    
961     if [[ ! -z $(typeset -f postremove) ]]
962     then
963     # rename the old one
964     local saved_postremove
965     saved_postremove=SAVED_$(typeset -f postremove)
966     eval "${saved_postremove}"
967     export -f SAVED_postremove
968     fi
969    }
970    
971    split_restore_variables()
972    {
973     export PNAME="${SAVED_PNAME}"
974     export PVER="${SAVED_PVER}"
975     export PBUILD="${SAVED_PBUILD}"
976     export PCATEGORIE="${SAVED_PCATEGORIE}"
977     export DESCRIPTION="${SAVED_DESCRIPTION}"
978     export HOMEPAGE="${SAVED_HOMEPAGE}"
979     export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"
980     export STATE="${SAVED_STATE}"
981     export PKGTYPE="${SAVED_PKGTYPE}"
982     export INHERITS="${SAVED_INHERITS}"
983     export DEPEND="${SAVED_DEPEND}"
984     export SDEPEND="${SAVED_SDEPEND}"
985     export PROVIDE="${SAVED_PROVIDE}"
986     export NOPKGBUILD="${SAVED_NOPKGBUILD}"
987    
988     # bindir too
989     export BINDIR="${SAVED_BINDIR}"
990    
991     # functions
992     if [[ ! -z $(typeset -f SAVED_preinstall) ]]
993     then
994     # rename the old one
995     local saved_preinstall
996     saved_preinstall=$(typeset -f SAVED_preinstall)
997     eval "${saved_preinstall/SAVED_/}"
998     export -f preinstall
999     fi
1000    
1001     if [[ ! -z $(typeset -f SAVED_postinstall) ]]
1002     then
1003     # rename the old one
1004     local saved_postinstall
1005     saved_postinstall=$(typeset -f SAVED_postinstall)
1006     eval "${saved_postinstall/SAVED_/}"
1007     export -f postinstall
1008     fi
1009    
1010     if [[ ! -z $(typeset -f SAVED_preremove) ]]
1011     then
1012     # rename the old one
1013     local saved_preremove
1014     saved_preremove=$(typeset -f SAVED_preremove)
1015     eval "${saved_preremove/SAVED_/}"
1016     export -f preremove
1017     fi
1018    
1019     if [[ ! -z $(typeset -f SAVED_postremove) ]]
1020     then
1021     # rename the old one
1022     local saved_postremove
1023     saved_postremove=$(typeset -f SAVED_postremove)
1024     eval "${saved_postremove/SAVED_/}"
1025     export -f postremove
1026     fi
1027    }
1028    
1029    split_unset_variables()
1030    {
1031     # unset saved vars; not needed anymore
1032     unset SAVED_PNAME
1033     unset SAVED_PVER
1034     unset SAVED_PBUILD
1035     unset SAVED_PCATEGORIE
1036     unset SAVED_DESCRIPTION
1037     unset SAVED_HOMEPAGE
1038     unset SAVED_SPECIAL_VARS
1039     unset SAVED_STATE
1040     unset SAVED_PKGTYPE
1041     unset SAVED_INHERITS
1042     unset SAVED_DEPEND
1043     unset SAVED_SDEPEND
1044     unset SAVED_PROVIDE
1045     unset SAVED_BINDIR
1046     unset SAVED_NOPKGBUILD
1047     unset SPLIT_PACKAGE_BASE
1048     unset -f SAVED_preinstall
1049     unset -f SAVED_postinstall
1050     unset -f SAVED_preremove
1051     unset -f SAVED_postremove
1052    }
1053    
1054  export_inherits()  export_inherits()
1055  {  {
1056   local include="$1"   local include="$1"
# Line 947  step_by_step() Line 1174  step_by_step()
1174  {  {
1175   if [[ ${STEP_BY_STEP} = true ]]   if [[ ${STEP_BY_STEP} = true ]]
1176   then   then
1177   echo "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"   echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1178   echo "Press [enter] to continue"   echo "Press [enter] to continue"
1179   read   read
1180   fi   fi
# Line 979  fi Line 1206  fi
1206  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
1207  if [[ $1 = calcmd5 ]]  if [[ $1 = calcmd5 ]]
1208  then  then
1209   if [ $# -ge 3 ]   if [ $# -ge 2 ]
1210   then   then
1211   SMAGENAME="$2"   SMAGENAME="$2"
1212   MD5DIR="$3"   MD5DIR="$3"
1213   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
1214    
1215     smagesource ${SMAGENAME} || die "download source failed"
1216    
1217   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
1218   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 1035  then Line 1264  then
1264   echo   echo
1265   else   else
1266   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
1267   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
1268   echo   echo
1269   echo   echo
1270   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
# Line 1057  then Line 1286  then
1286   # get smage   # get smage
1287   SMAGENAME="$2"   SMAGENAME="$2"
1288   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
1289   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
1290    
1291   download_sources   download_sources
1292   exit 0   exit 0
# Line 1069  then Line 1298  then
1298   # set correct SMAGENAME   # set correct SMAGENAME
1299   SMAGENAME="$2"   SMAGENAME="$2"
1300   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
1301   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
1302    
1303   regen_mage_tree   regen_mage_tree
1304    
1305   # build several targets   # build several targets
1306   if [ -n "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
1307   then   then
1308   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
1309   do   do
# Line 1087  then Line 1316  then
1316   --parch "${ARCH}" \   --parch "${ARCH}" \
1317   --target "${target}"   --target "${target}"
1318   done   done
1319    
1320     # build several subpackages
1321     elif [[ -n ${SPLIT_PACKAGES} ]]
1322     then
1323     split_save_variables
1324     for subpackage in ${SPLIT_PACKAGES}
1325     do
1326     # get the right variables for the split
1327     export PNAME="${subpackage}"
1328     split_info_${subpackage}
1329     # build md5sum for existing packages
1330     generate_package_md5sum \
1331     --pcat "${PCATEGORIE}" \
1332     --pname "${PNAME}" \
1333     --pver "${PVER}" \
1334     --pbuild "${PBUILD}" \
1335     --parch "${ARCH}"
1336     # restore smage environment
1337     split_restore_variables
1338     done
1339     # unset all saved smage variables
1340     split_unset_variables
1341    
1342   else   else
1343   # build md5sum for existing packages   # build md5sum for existing packages
1344   generate_package_md5sum \   generate_package_md5sum \
# Line 1094  then Line 1346  then
1346   --pname "${PNAME}" \   --pname "${PNAME}" \
1347   --pver "${PVER}" \   --pver "${PVER}" \
1348   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
1349   --parch "${ARCH}" \   --parch "${ARCH}"
  --target "${target}"  
1350   fi   fi
1351    
1352   exit 0   exit 0
# Line 1109  then Line 1360  then
1360    
1361   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
1362    
1363   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
1364    
1365   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
1366   then   then
# Line 1158  fi Line 1409  fi
1409  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
1410  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
1411    
1412  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
1413  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"
1414  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
1415    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
1416    
1417  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
1418  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
# Line 1239  fi Line 1491  fi
1491  [[ ! -d /var/log/smage ]] && install -d /var/log/smage  [[ ! -d /var/log/smage ]] && install -d /var/log/smage
1492  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
1493    
1494  src_prepare || die "src_prepare failed" | ${SMAGE_LOG_CMD}  src_prepare | ${SMAGE_LOG_CMD}
1495  step_by_step $_  die_pipestatus 0 "src_prepare failed"
 src_compile || die "src_compile failed" | ${SMAGE_LOG_CMD}  
 step_by_step $_  
 src_install || die "src_install failed" | ${SMAGE_LOG_CMD}  
1496  step_by_step $_  step_by_step $_
1497    
1498    src_compile | ${SMAGE_LOG_CMD}
1499    die_pipestatus 0 "src_compile failed"
1500    step_by_step $_
1501    
1502  # compressing doc, info & man files  # build several subpackages
1503  if [ -d ${BUILDDIR}/builded/usr/share/man ]  if [[ -n ${SPLIT_PACKAGES} ]]
1504  then  then
1505   echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"   # save bindir & pname
1506   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   split_save_variables
1507     export SAVED_BINDIR="${BINDIR}"
1508     for subpackage in ${SPLIT_PACKAGES}
1509     do
1510     if typeset -f src_install_${subpackage} > /dev/null
1511     then
1512     # export subpackage bindir
1513     export BINDIR="${SAVED_BINDIR}_${subpackage}"
1514     # export PNAME, several internal function and include
1515     # rely on this variable
1516     export PNAME="${subpackage}"
1517    
1518     echo
1519     echo -en "${COLBLUE}*** ${COLDEFAULT}"
1520     echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
1521     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
1522     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
1523    
1524     src_install_${subpackage} | ${SMAGE_LOG_CMD}
1525     die_pipestatus 0 "src_install_${subpackage} failed"
1526     step_by_step $_
1527     fi
1528     done
1529     # restore bindir & pname
1530     split_restore_variables
1531     # unset all saved smage variables
1532     split_unset_variables
1533    else
1534     src_install | ${SMAGE_LOG_CMD}
1535     die_pipestatus 0 "src_install failed"
1536     step_by_step $_
1537  fi  fi
1538    
1539  if [ -d ${BUILDDIR}/builded/usr/share/info ]  # compressing doc, info & man files
1540    if [[ -n ${SPLIT_PACKAGES} ]]
1541  then  then
1542   echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"   for subpackage in ${SPLIT_PACKAGES}
1543   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   do
1544     mcompressdocs ${BINDIR}_${subpackage}
1545     done
1546    else
1547     mcompressdocs ${BINDIR}
1548  fi  fi
1549    
1550    
1551  # stripping all bins and libs  # stripping all bins and libs
1552  case ${NOSTRIP} in  case ${NOSTRIP} in
1553   true|TRUE|yes|y)   true|TRUE|yes|y)
1554   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   echo -e "NOSTRIP=true detected; Package will not be stripped ..."
1555   ;;   ;;
1556   *)   *)
1557   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"   if [[ -n ${SPLIT_PACKAGES} ]]
1558   mstripbins ${BINDIR}   then
1559   echo -e "${COLBLUE}===${COLGREEN} stripping libraries ...${COLDEFAULT}"   for subpackage in ${SPLIT_PACKAGES}
1560   mstriplibs ${BINDIR}   do
1561     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
1562     mstripbins ${BINDIR}_${subpackage}
1563     echo -e "${COLBLUE}===${COLGREEN} stripping libraries for '${subpackage}' ...${COLDEFAULT}"
1564     mstriplibs ${BINDIR}_${subpackage}
1565     done
1566     else
1567     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
1568     mstripbins ${BINDIR}
1569     echo -e "${COLBLUE}===${COLGREEN} stripping libraries ...${COLDEFAULT}"
1570     mstriplibs ${BINDIR}
1571     fi
1572   ;;   ;;
1573  esac  esac
1574    
# Line 1280  case ${NOPKGBUILD} in Line 1579  case ${NOPKGBUILD} in
1579   ;;   ;;
1580   *)   *)
1581   # build several targets   # build several targets
1582   if [ -n "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
1583   then   then
1584   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
1585   do   do
# Line 1306  case ${NOPKGBUILD} in Line 1605  case ${NOPKGBUILD} in
1605    
1606   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1607   done   done
1608    
1609     # build several subpackages
1610     elif [[ -n ${SPLIT_PACKAGES} ]]
1611     then
1612     split_save_variables
1613     for subpackage in ${SPLIT_PACKAGES}
1614     do
1615     # get the right variables for the split
1616     export PNAME="${subpackage}"
1617     split_info_${PNAME}
1618    
1619     # jump to next one if NOPKGBUILD is set in split_info
1620     case ${NOPKGBUILD} in
1621     true|TRUE|yes|y) continue ;;
1622     esac
1623    
1624     # check if an special subpackage_pkgbuild exists
1625     if typeset -f ${PNAME}_pkgbuild > /dev/null
1626     then
1627     # run it
1628     ${PNAME}_pkgbuild
1629     fi
1630     # now create the target package
1631     ${MLIBDIR}/pkgbuild_dir.sh \
1632     "${PNAME}-${PVER}-${ARCH}-${PBUILD}" \
1633     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
1634    
1635     # build pkg-md5-sum if requested
1636     generate_package_md5sum \
1637     --pcat "${PCATEGORIE}" \
1638     --pname "${PNAME}" \
1639     --pver "${PVER}" \
1640     --pbuild "${PBUILD}" \
1641     --parch "${ARCH}"
1642    
1643     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1644    
1645     # restore smage environment
1646     split_restore_variables
1647     done
1648     # unset all saved smage variables
1649     split_unset_variables
1650    
1651   else   else
1652   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
1653    

Legend:
Removed from v.891  
changed lines
  Added in v.1435